package testaaminen;


/**
 * Esimerkki testaamisesta
 * @author vesal
 * @version 1.2.2021
 *
 */
public class Poista {

    /**
     * @param jono josta poistetaan
     * @param poistettava mitä poistetaan
     * @return jonon jossa ei ole yhtään poistettavaa
     * @example
     * <pre name="test">
     *   poista("Catcat"   ,"at")  =>  "Cc";
     *   poista("Paatti"   ,"at")  ===  "Pi";
     *   poista("Puatit"   ,"at")  ===  "Puit";
     *   poista("Abba"     ,"bb")  ===  "Aa";
     *   poista("Abbababba","ba")  ===  "Abb";
     *   poista("AbbabaaB" ,"ba")  ===  "AB";
     *   poista("Abba"     ,"Ab")  ===  "ba";
     *   poista("Abba"     ,"cc")  ===  "Abba";
     *   poista("Abba"     ,""  )  ===  "Abba";
     *   poista(""         ,"Aa")  ===  "";
     *   poista(""         ,""  )  ===  "";
     *   poista(null       ,""  )  ===  "";
     *   poista(null       ,"k"  ) ===  "";    
     *   poista("Kissa"    ,null)  ===  "Kissa";
     * </pre>
     */
    @SuppressWarnings("unused")
    public static String poista(String jono, String poistettava) {
        return demo.d3.Poista.poista(jono, poistettava); 
    }

    
    private static int poistatesti(String jono, String mita, String odotettuTulos) {
        String vaihdettu = poista(jono, mita);
        if ( vaihdettu.equals(odotettuTulos ) ) return 0;
        System.out.println(jono + " => " + vaihdettu + " piti tulla "
                + odotettuTulos);
        return 1;
    }
    
    /**
     * Testataan poista-aliohjelmaa
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int v = 0;
        v += poistatesti("Catcat", "at", "Cc");
        v += poistatesti("Paatti", "at", "Pi");
        v += poistatesti("Puatit", "at", "Puit");
        v += poistatesti("Abba", "bb", "Aa");
        v += poistatesti("Abbababba", "ba", "Abb");
        v += poistatesti("AbbabaaB", "ba", "AB");
        v += poistatesti("Abba", "Aa", "Abba");
        v += poistatesti("Abba", "", "Abba");
        v += poistatesti("", "Aa", "");
        v += poistatesti("", "", "");
        if ( v != 0 ) System.out.println("Virheitä: " + v);
        else System.out.println("Hyvin meni!");
    }

}