package olio;

/**
 * @author vesal
 * @version 14.2.2023
 *
 */
public interface AikaRajapinta {

    /**
     * Asettaa uuden ajan ja pitää huolen että aika on aina oikeaa muotoa.
     * @param ih asetettava tuntimäärä
     * @param im asetettava minuuttimäärä
     * @return montako vuorokautta jäi yli
     * <pre name="test">
     *  Aika a1 = new Aika();
     *  a1.aseta(12,15); a1.toString() === "12:15";
     *  a1.aseta(15,45); a1.toString() === "15:45";
     *  a1.aseta(-49,-125); a1.toString() === "20:55";
     * </pre>
     */
    int aseta(int ih, int im);


    /**
     * @return aika muodossa 09:05
     * @example
     * <pre name="test">
     *   Aika a = new Aika(12,15);
     *   a.toString() === "12:15";
     *   a = new Aika(9,5);
     *   a.toString() === "09:05";
     * </pre>
     */
    @Override
    String toString();


    /**
     * Lisää aikaan lisamin
     * @param lisamin lisättävät minuutit
     * @example
     * <pre name="test">
     *   Aika a = new Aika(12,15);
     *   a.lisaa(50);
     *   a.toString() === "13:05";
     * </pre>
     */
    void lisaa(int lisamin);


    /**
     * @return nykyiset tunnit
     */
    int getH();


    /**
     * @return nykyiset tunnit
     */
    int getM();

}