package wbKerho;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JSplitPane;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.AbstractListModel;
import javax.swing.SwingConstants;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import guilib.EditPanel;

import java.awt.Dimension;

import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.UIManager;

/**
 * Kerho-ohjelman pääikkuna
 * @author vesal
 * @version 13.1.2014
 */
public class KerhoGUI extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private final JPanel panelNappulat = new JPanel();
	private final JButton btnUusi = new JButton("Uusi");
	private final JButton btnTalleta = new JButton("Talleta");
	private final JPanel panelJasenNappulat = new JPanel();
	private final JPanel panelHarrastusNappulat = new JPanel();
	private final JButton btnUusiHarrastus = new JButton("Uusi harrastus");
	private final JSplitPane splitPanelListaJasentiedot = new JSplitPane();
	private final JPanel panelLista = new JPanel();
	private final JPanel panelHaku = new JPanel();
	private final JLabel lblHakuehto = new JLabel("Hakuehto");
	private final JTextField editHaku = new JTextField();
	private final JLabel lblJasenet = new JLabel("J\u00E4senet");
	private final JScrollPane scrolJasenet = new JScrollPane();
	private final JList<String> listJasenet = new JList<String>();
	private final JSplitPane splitPanelJasenHarrastukset = new JSplitPane();
	private final JPanel panelHarrastukset = new JPanel();
	private final JLabel lblJsenenHarrastukset = new JLabel("J\u00E4senen harrastukset");
	private final JScrollPane scrollHarrastusTable = new JScrollPane();
	private final JTable tableHarrastus = new JTable();
	private final JPanel panelJasenTiedot = new JPanel();
	private final JLabel lblJasenenTiedot = new JLabel("J\u00E4senen tiedot");
	private final JLabel lblVirhe = new JLabel("");
	private final JScrollPane scrollJasen = new JScrollPane();
	private final JPanel panelJasen = new JPanel();
	private final JPanel boxJasen = new JPanel();
	private final EditPanel editPanelNimi = new EditPanel();
	private final EditPanel editPanelHetu = new EditPanel();
	private final EditPanel editPanelKatu = new EditPanel();
	private final EditPanel editPanel_3 = new EditPanel();
	private final EditPanel editPanel_4 = new EditPanel();
	private final EditPanel editPanel_5 = new EditPanel();
	private final JComboBox<String> cbKentat = new JComboBox<String>();
	private final JMenuBar menuBar = new JMenuBar();
	private final JMenu mnTiedosto = new JMenu("Tiedosto");
	private final JMenuItem mntmAvaa = new JMenuItem("Avaa");

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel");
		} catch (Throwable e) {
			e.printStackTrace();
		}
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					KerhoGUI frame = new KerhoGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public KerhoGUI() {
		setTitle("Kerho");
		editHaku.setColumns(10);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 688, 417);
		
		setJMenuBar(menuBar);
		
		menuBar.add(mnTiedosto);
		
		mnTiedosto.add(mntmAvaa);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		contentPane.add(panelNappulat, BorderLayout.SOUTH);
		panelNappulat.setLayout(new BorderLayout(0, 0));
		
		panelNappulat.add(panelJasenNappulat, BorderLayout.WEST);
		panelJasenNappulat.add(btnUusi);
		panelJasenNappulat.add(btnTalleta);
		
		panelNappulat.add(panelHarrastusNappulat, BorderLayout.EAST);
		
		panelHarrastusNappulat.add(btnUusiHarrastus);
		
		contentPane.add(splitPanelListaJasentiedot, BorderLayout.CENTER);
		panelLista.setMinimumSize(new Dimension(100, 10));
		panelLista.setPreferredSize(new Dimension(100, 10));
		
		splitPanelListaJasentiedot.setLeftComponent(panelLista);
		panelLista.setLayout(new BorderLayout(0, 0));
		
		panelLista.add(panelHaku, BorderLayout.NORTH);
		panelHaku.setLayout(new BoxLayout(panelHaku, BoxLayout.Y_AXIS));
		
		panelHaku.add(lblHakuehto);
		cbKentat.setModel(new DefaultComboBoxModel<String>(new String[] {"nimi", "hetu", "katuosoite"}));
		
		panelHaku.add(cbKentat);
		
		panelHaku.add(editHaku);
		
		panelHaku.add(lblJasenet);
		
		panelLista.add(scrolJasenet, BorderLayout.CENTER);
		listJasenet.setModel(new AbstractListModel<String>() {
			private static final long serialVersionUID = 1L;
			String[] values = new String[] {"Ankka Aku", "Ankka Iines", "Hopo Hessu", "Susi Sepe"};
			public int getSize() {
				return values.length;
			}
			public String getElementAt(int index) {
				return values[index];
			}
		});
		
		scrolJasenet.setViewportView(listJasenet);
		splitPanelJasenHarrastukset.setResizeWeight(0.7);
		
		splitPanelListaJasentiedot.setRightComponent(splitPanelJasenHarrastukset);
		
		splitPanelJasenHarrastukset.setRightComponent(panelHarrastukset);
		panelHarrastukset.setLayout(new BorderLayout(0, 0));
		lblJsenenHarrastukset.setHorizontalAlignment(SwingConstants.CENTER);
		
		panelHarrastukset.add(lblJsenenHarrastukset, BorderLayout.NORTH);
		
		panelHarrastukset.add(scrollHarrastusTable, BorderLayout.CENTER);
		tableHarrastus.setAutoCreateRowSorter(true);
		tableHarrastus.setModel(new DefaultTableModel(
			new Object[][] {
				{"kalastus", new Integer(1955), new Integer(20)},
				{"laiskottelu", new Integer(1950), new Integer(20)},
				{"ty\u00F6n pakoilu", new Integer(1952), new Integer(40)},
			},
			new String[] {
				"ala", "aloitusvuosi", "h/vko"
			}
		));
		tableHarrastus.getColumnModel().getColumn(0).setPreferredWidth(92);
		tableHarrastus.getColumnModel().getColumn(1).setPreferredWidth(46);
		tableHarrastus.getColumnModel().getColumn(2).setPreferredWidth(44);
		
		scrollHarrastusTable.setViewportView(tableHarrastus);
		
		splitPanelJasenHarrastukset.setLeftComponent(panelJasenTiedot);
		panelJasenTiedot.setLayout(new BorderLayout(0, 0));
		lblJasenenTiedot.setHorizontalAlignment(SwingConstants.CENTER);
		
		panelJasenTiedot.add(lblJasenenTiedot, BorderLayout.NORTH);
		
		panelJasenTiedot.add(lblVirhe, BorderLayout.SOUTH);
		
		panelJasenTiedot.add(scrollJasen, BorderLayout.CENTER);
		
		scrollJasen.setViewportView(panelJasen);
		panelJasen.setLayout(new BorderLayout(0, 0));
		
		panelJasen.add(boxJasen, BorderLayout.NORTH);
		boxJasen.setLayout(new BoxLayout(boxJasen, BoxLayout.Y_AXIS));
		editPanelNimi.setText("Ankka Aku");
		editPanelNimi.setCaption("nimi");
		
		boxJasen.add(editPanelNimi);
		editPanelHetu.setText("010245-123U");
		editPanelHetu.setCaption("hetu");
		
		boxJasen.add(editPanelHetu);
		editPanelKatu.setCaption("katuosoite");
		editPanelKatu.setText("Ankkakuja 6");
		
		boxJasen.add(editPanelKatu);
		
		boxJasen.add(editPanel_3);
		
		boxJasen.add(editPanel_4);
		boxJasen.add(editPanel_5);
	}

}
