package fxAanestysRB;
	


import fi.jyu.mit.fxgui.Dialogs;
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;
import javafx.scene.text.Font;
import javafx.geometry.Insets;
import javafx.geometry.Pos;


/**
 * Pääohjelma äänestykselle.  Tehty pelkällä Javalla
 * @author vesal
 * @version 31.1.2016
 *
 */
public class AanestysMain2 extends Application {
	@Override
	public void start(Stage primaryStage) {
		try {
			Pane root = luoNaytto();
			Scene scene = new Scene(root);
			// scene.getStylesheets().add(getClass().getResource("aanestys.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.setTitle("Äänestys");
			primaryStage.show();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	/**
	 * Käynnistetään äänestys
	 * @param args ei käytössä
	 */
	public static void main(String[] args) {
		launch(args);
	}
	
	
	private Pane luoNaytto() {
	    BorderPane pane = new BorderPane();
	    Label labelAihe = new Label("Onko ohjelmointi kivaa?");
	    BorderPane.setAlignment(labelAihe, Pos.CENTER);
	    Font font = new Font("Arial Bold", 18);
	    labelAihe.setFont(font);
	    labelAihe.setPadding(new Insets(10, 10, 0, 10));
	    pane.setTop(labelAihe);
	    
	    Button buttonAanesta = new Button("Äänestä"); 
        BorderPane.setAlignment(buttonAanesta, Pos.CENTER);
        BorderPane.setMargin(buttonAanesta, new Insets(0, 0, 20, 0));
	    pane.setBottom(buttonAanesta);
        buttonAanesta.setDefaultButton(true);

	    VBox vbox = new VBox();
        pane.setCenter(vbox);
        BorderPane.setMargin(vbox, new Insets(20, 0, 0, 0));
	    
	    labelValittu = new Label("Valittu: Kyllä");
	    labelValittu.setMaxWidth(1000);
	    labelValittu.setAlignment(Pos.CENTER);
	    vbox.getChildren().add(labelValittu);
         
	    VBox vbox2 = new VBox();
	    vbox.getChildren().add(vbox2);
        vbox2.setPadding(new Insets(10, 10, 10, 10));
        VBox.setMargin(vbox2, new Insets(5, 20, 20, 20));
        vbox2.setStyle("-fx-border-color: black;");

        Label labelValitse = new Label("Valitse:");
        vbox2.getChildren().add(labelValitse);

        ScrollPane sp = new ScrollPane();
        sp.getStyleClass().add("edge-to-edge");
        vbox2.getChildren().add(sp);
        
        VBox vbox3 = new VBox();
        sp.setContent(vbox3);
        vbox3.setSpacing(10.0);
        vbox3.setPadding(new Insets(10, 0, 10, 20));
        
	    groupAanestys = new ToggleGroup();

	    RadioButton rb0 = new RadioButton("_Kyllä");
	    vbox3.getChildren().add(rb0);
        rb0.setToggleGroup(groupAanestys);
        rb0.setId("rb0");

	    RadioButton rb1 = new RadioButton("_Ei");
        vbox3.getChildren().add(rb1);
        rb1.setToggleGroup(groupAanestys);
        rb1.setId("rb1");
 
        RadioButton rb2 = new RadioButton("_En osaa sanoa");
        vbox3.getChildren().add(rb2);
        rb2.setToggleGroup(groupAanestys);
        rb2.setId("rb2");
       
        buttonAanesta.setOnAction( (e) -> handleAanesta() );
	    
	    initialize();
	    return pane;
	}
	
	
    private Label labelValittu;
    private ToggleGroup groupAanestys;

    void handleAanesta() {
       aanesta();
    }
    

    private void initialize() {
        groupAanestys.selectedToggleProperty().addListener( (e) -> nayta());
        labelValittu.setText("");
    }
    
    
    private void nayta() {
        RadioButton rb = (RadioButton)groupAanestys.getSelectedToggle();
        if ( rb == null ) return;
        labelValittu.setText("Valittu: " + rb.getText().replaceFirst("_", ""));
    }


    private void aanesta() {
        String kohde = "";
        RadioButton rb = (RadioButton)groupAanestys.getSelectedToggle();
        if ( rb == null ) return;
        String id = rb.getId();
        int i = Integer.parseInt(id.substring(2));
        kohde = rb.getText().replaceFirst("_", "");
        Dialogs.showMessageDialog("Äänestit siis: " + kohde + " " + i);
    }
	
	
}
