package laskuri;

/**
 * Luokka, joka laskee yhden sanan esiintymiskertoja
 * @author Vesa Lappalainen
 * @version 1.0, 11.03.2003
 * 
 * <pre>
 *  kissa 
 *    1 
 * </pre>
 * 
 */
public class Sana {
    private int lkm;
    private String teksti;

    
    /**
     * Luodaan uusi sana, lkm = 0;
     * @param s jono joksi sana alustetaan
     */
    public Sana(String s) {
        lkm = 0;
        teksti = s;
    }
    
    
    /**
     * Verrataan onko tutkittava jono
     * @param s tutkittava jono
     * @return true jos sama kuin s
     * <pre name="test">
     *   Sana sana = new Sana("kissa");
     *   sana.oletko("kissa") === true;
     *   sana.oletko("kISSA") === true;
     *   sana.oletko("kiss")  === false;
     * </pre>
     */
    public boolean oletko(String s) {
        return teksti.equalsIgnoreCase(s);
    }
    
    
    /**
     * Lisää sanan esiintymien lukumäärää
     * <pre name="test">
     *   Sana sana = new Sana("kissa");
     *   sana.toString() === "kissa: 0";
     *   sana.lisaa();
     *   sana.toString() === "kissa: 1";
     *   sana.lisaa();
     *   sana.toString() === "kissa: 2";
     * </pre>
     */
    public void lisaa() {
       lkm++; 
    }
    
    
    /**
     * @return sana ja määrä merkkijonona    
     * <pre name="test">
     *   Sana sana = new Sana("kissa");
     *   sana.toString() === "kissa: 0";
     * </pre>
     */
    @Override
    public String toString() {
        return teksti + ": " + lkm;
    }    
    
}
